export interface PatternReplacementSet {
    [key: string]: {
        regexp?: RegExp;
        map: {
            [key: string]: string;
        };
    };
}
export interface CopyOptions {
    forceDelete?: boolean;
    pathReplacements?: {
        [key: string]: string;
    };
    contentReplacements?: {
        [key: string]: string;
    };
    pathPatternReplacements?: PatternReplacementSet;
    contentPatternReplacements?: PatternReplacementSet;
    ignore?: string;
}
export declare function copyDirSyncRecursive(to: string, from: string, opt?: CopyOptions, pathFilter?: (x: string) => boolean, contentFilter?: (x: string) => boolean): void;
export declare function removeDirSyncRecursive(dirPath: string): void;
export declare function copyFileSync(sourcePath: string, targetPath: string): void;
